.ORG 0x0000    
    JMP main  

main:

    LDI R26, 0x00     
    LDI R27, 0xA0      ; X -> Address of matrix 0xA000
    
    LDI R18, 10        ; Number of rows
    LDI R28, 1         ; True for diagonal
    CLR R0             ; False for not diagonal
    
; ===============================================================
check_row: 

    LDI R17, 10        ; Reset column counter for each row

check_diagonal:    
    LD R16, X+                
    CPI R16, 0               ; Check if value is zero
    BREQ end_not_diagonal    ; If zero -> not diagonal       

    DEC R17
    BRNE check_zero          ; Continue to check zeros
    
    DEC R18
    BRNE check_row           ; If rows remain, check next row
    LDI R27, 1
    JMP end_diagonal         ; If all rows checked, it's diagonal

; ===============================================================
check_zero: 
    
    LD R16, X+             
    CPI R16, 0              ; Compare with 0       
    BRNE end_not_diagonal   ; If not 0 -> not diagonal

    DEC R17
    BRNE check_zero          ; Continue checking zeros 

    JMP check_row  

; ===============================================================
end_diagonal:
    STS 0xB000, R28
    JMP finish

end_not_diagonal:
    STS 0xB000, R0

finish: 
    JMP finish 