.ORG 0x0000    
    JMP main  

; ====================================================================================
main:
 
    LDI R30, 0x00       ; load address    
    LDI R31, 0x80 

    LDI R26, 0x00       ; store address
    LDI R27, 0x90  

; ====================================================================================
check_number:

    LD R16, Z+        
    CPI R16, 0     
    BRGE end            ; if zero go to end
    call check_prime   ; check prime number
    
    CPI R17, 1         ; if R16 = prime -> R17 = 1  else R17 = 0   
    BRNE store_prime   ; if R17 = 1 -> store prime  

; ====================================================================================
check_counter:

    CPI R31, 0x90      ; check end of number range  
    BRNE check_number  ; jump to check next number 

; ====================================================================================    
end:

    JMP end     

; ====================================================================================
store_prime:

    ST X+, R16           ; Store Prime number 
    JMP check_counter    ; next 

; ====================================================================================
check_prime:

    LDI R17, 1             ; set R17  (until R17 = 1 -> number is Prime)

    LDI R18, 2         
    CALL check_div    
    CPI R17, 1            
    BRNE end_check_prime   ; if number still prime continue else jmp to end check 

    LDI R18, 3    
    CALL check_div
    CPI R17, 1            
    BRNE end_check_prime   ; if number still prime continue else jmp to end check 

    LDI R18, 5      
    CALL check_div
    CPI R17, 1            
    BRNE end_check_prime   ; if number still prime continue else jmp to end check 

    LDI R18, 7         
    CALL check_div
    CPI R17, 1            
    BRNE end_check_prime   ; if number still prime continue else jmp to end check 

    LDI R18, 11        
    CALL check_div
    CPI R17, 1            
    BRNE end_check_prime   ; if number still prime continue else jmp to end check 

    LDI R18, 13   
    CALL check_div
end_check_prime:
    RET

; ====================================================================================
check_div:

    mov R19, R16     

div_loop:               ; loop to check divisible 

    SUB R19, R18        
    BRMI end_check_div  ; BRMI = branch if minus ( N = 1 ) -> 
                        ; not divisible -> still prime

    BRGE divisible       ; Branch if divisible (Z = 1) -> 
                        ; divisible -> not prime

    JMP div_loop        ; continue loop       

; ====================================================================================
divisible:            
    LDI R17, 0          ; set R17 = 1 -> number is not Prime 
end_check_div:
    RET                
; ====================================================================================

    